# Yocto

...

## Get the repository

```shell
mkdir yocto-bf
cd yocto-bf
repo init -u "https://git.blackfinn.de/yocto/linux-blackfinn.git"
repo sync
```

## Build environment

For details see <https://git.blackfinn.de/docker/oe-buildenv>.

### Execute

```shell
docker run -it --rm --network host -v=/var/lib/sss/pipes/:/var/lib/sss/pipes/:rw -v $(pwd):$(pwd) -w $(pwd) -u $(id -u $USER):$(id -g $USER) oe-buildenv /bin/bash
```

## Set Environment

```shell
MACHINE=<machineconf> source blackfinn-init-build-env
```

Supported machineconfs:

* qemuarm
* beaglebone-yocto
* raspberrypi3-64
* raspberrypi4-64


## Build the Image
```shell
bitbake <image_name>
```

Supported images:

* console-image
* console-dev-image
* docker-image

## Flash the Image

### beaglebone-yocto

```shell
dd if=tmp/deploy/images/beaglebone-yocto/docker-image-beaglebone-yocto.wic of=/dev/<sd_card>
```

### raspberrypiX-64

```shell
bmaptool copy --bmap \
	tmp/deploy/images/raspberrypiX-64/docker-image-raspberrypiX-64.wic.bmap \
	tmp/deploy/images/raspberrypiX-64/docker-image-raspberrypiX-64.wic.bz2 \
	/dev/<sd_card>
```

## opkg package handling

### Build index

```shell
bitbake package index
```

### Synchronize packages

```shell
rsync -avz --progress build/tmp/deploy/ipk/ /srv/files.blackfinn.de/data/yocto/gatesgarth/
```
